# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Name:		perl-JSON-XS
Summary:	JSON serializing/de-serializing, done correctly and fast
Epoch:		1
Version:	3.03
Release:	1.%{__distinit}%{__distvers}
License:	GPL+ or Artistic
Group:		Development/Libraries
URL:		http://search.cpan.org/dist/JSON-XS/
Source0:	http://search.cpan.org/CPAN/authors/id/M/ML/MLEHMANN/JSON-XS-%{version}.tar.gz
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	gcc
BuildRequires:	make
BuildRequires:	perl
%if 0%{?fedora} > 6 || 0%{?rhel} > 5
BuildRequires:	perl-devel
%endif
%if 0%{?fedora} > 20 || 0%{?rhel} > 7
BuildRequires:	perl-generators
%endif
BuildRequires:	perl(Canary::Stability)
BuildRequires:	perl(ExtUtils::MakeMaker)
# Module Runtime
BuildRequires:	perl(common::sense)
BuildRequires:	perl(Exporter)
BuildRequires:	perl(Types::Serialiser)
BuildRequires:	perl(XSLoader)
# Script Runtime
BuildRequires:	perl(Getopt::Long)
BuildRequires:	perl(Storable)
BuildRequires:	perl(strict)
# Test Suite
BuildRequires:	perl(Data::Dumper)
BuildRequires:	perl(Encode)
BuildRequires:	perl(Test)
BuildRequires:	perl(Test::More)
BuildRequires:	perl(Tie::Array)
BuildRequires:	perl(Tie::Hash)
BuildRequires:	perl(utf8)
BuildRequires:	perl(warnings)
# Dependencies
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))

# Avoid unwanted provides and dependencies (rpm 4.9 onwards)
%{?perl_default_filter}

%description
This module converts Perl data structures to JSON and vice versa. Its
primary goal is to be correct and its secondary goal is to be fast. To
reach the latter goal it was written in C.

%prep
%setup -q -n JSON-XS-%{version}

# Fix shellbangs
perl -pi -e 's|^#!/opt/bin/perl|#!/usr/bin/perl|' eg/*

# Avoid doc-file dependencies
chmod -c -x eg/*

%build
perl Makefile.PL INSTALLDIRS=vendor OPTIMIZE="%{optflags}"
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
find %{buildroot} -type f -name '*.bs' -empty -delete
%{_fixperms} %{buildroot}

%check
make test

%clean
rm -rf %{buildroot}

%files
%if 0%{?_licensedir:1}
%license COPYING
%else
%doc COPYING
%endif
%doc Changes README eg/
%{_bindir}/json_xs
%{perl_vendorarch}/auto/JSON/
%{perl_vendorarch}/JSON/
%{_mandir}/man1/json_xs.1*
%{_mandir}/man3/JSON::XS.3*
%{_mandir}/man3/JSON::XS::Boolean.3*

%changelog
* Thu Nov 17 2016 Paul Howarth <paul@city-fan.org> - 1:3.03-1
- Update to 3.03
  - Fix a bug introduced by a perl bug workaround that would cause incremental
    parsing to fail with an sv_chop panic
  - json_xs: toformat failure error message fixed
  - json_xs: Allow cyclic data structures in CBOR

* Mon May 16 2016 Paul Howarth <paul@city-fan.org> - 1:3.02-2
- BR: perl-generators where possible
- Simplify find commands using -empty and -delete

* Sat Feb 27 2016 Paul Howarth <paul@city-fan.org> - 1:3.02-1
- Update to 3.02
  - allow_nonref now affects booleans (\1, $Types::Serialiser::Boolean) as well
  - Allow literal tabs in strings in relaxed mode
  - Support "cbor" format in json_xs tool
  - Support (and fix) calling encode and decode in list context
  - Work around a bug in older perls crashing when presented with shared hash
    keys
  - Use stability canary
- Classify buildreqs by usage

* Fri Aug 29 2014 Paul Howarth <paul@city-fan.org> - 1:3.01-4
- Drop %%defattr, redundant since rpm 4.4
- Use %%license where possible

* Tue Oct 29 2013 Paul Howarth <paul@city-fan.org> - 1:3.01-1
- Update to 3.01
  - Backport to perls < 5.16
- Drop upstreamed compatibility patch

* Tue Oct 29 2013 Paul Howarth <paul@city-fan.org> - 1:3.0-1
- Update to 3.0
  - Implemented an object tagging extension (using the Types::Serialiser
    serialisation protocol)
  - Reworked the documentation regarding object serialisation, adding a new
    OBJECT SERIALISATION section that explains the whole process
  - New setting: allow_tags
  - Switch to Types::Serialiser booleans
  - Remove to_json/from_json
  - Other minor improvements to the documentation
- Remove provides filter following major version bump
- Specify all dependencies
- Add patch for compatibility with perl < 5.16

* Tue Jul 16 2013 Paul Howarth <paul@city-fan.org> - 1:2.34-2
- Perl 5.18 rebuild

* Sat May 25 2013 Paul Howarth <paul@city-fan.org> - 1:2.34-1
- Update to 2.34
  - Handle hash randomization in perl 5.18
  - When canonicalising, only allocate up to 64 hash key pointers on the stack;
    for larger hashes, use the heap, to avoid using too much stack space
  - Discuss the problem with setlocale

* Thu Aug  2 2012 Paul Howarth <paul@city-fan.org> - 1:2.33-1
- Update to 2.33
  - Internal encode/decode XS wrappers did not expect stack moves caused by
    callbacks
  - Add bencode as to/from option in bin/json_xs
  - Add -e option to json_xs, and none and string in/out formats

* Fri Jun 22 2012 Paul Howarth <paul@city-fan.org> - 1:2.32-2
- BR: perl(Data::Dumper), perl(Encode), perl(Test)
- Install to vendor directories
- Don't need to remove empty directories from the buildroot
- Drop support for old distributions prior to FC-3:
  - Drop rpath-avoidance kludge
  - Don't need to define %%{perl_vendorarch}
  - Use %%{_fixperms} macro rather than our own chmod incantation
  - Use DESTDIR rather than PERL_INSTALL_ROOT

* Thu Aug 11 2011 Paul Howarth <paul@city-fan.org> - 1:2.32-1
- Update to 2.32:
  - Fix a bug in the initial whitespace accumulation

* Wed Jul 27 2011 Paul Howarth <paul@city-fan.org> - 1:2.31-1
- Update to 2.31:
  - Don't accumulate initial whitespace in the incremental buffer (this can be
    useful to allow whitespace-keepalive on a tcp connection without triggering
    the max_size limit)
  - Properly croak on some invalid inputs that are not strings (e.g. undef)
    when trying to decode a JSON text

* Tue Jun 28 2011 Paul Howarth <paul@city-fan.org> - 1:2.30-3
- Rebuild for perl 5.14.1 in Rawhide
- Tweak provides filter not to conflict with new Fedora macros
- Nobody else likes macros for commands
- Fix dist tag for CentOS 6 and Scientific Linux

* Fri Jan 28 2011 Paul Howarth <paul@city-fan.org> - 1:2.30-2
- Import from Fedora

* Mon Oct 11 2010 Marcela Mašláňová <mmaslano@redhat.com> - 1:2.30-1
- Update

* Sun May 02 2010 Marcela Maslanova <mmaslano@redhat.com> - 1:2.27-2
- Mass rebuild with perl 5.12.0

* Sat Feb 27 2010 Chris Weyl <cweyl@alumni.drew.edu> - 1:2.27-1
- Update by Fedora::App::MaintainerTools 0.004
- PERL_INSTALL_ROOT => DESTDIR
- Added a new br on perl(common::sense) (version 0)
- Added a new req on perl(common::sense) (version 0)

* Mon Dec  7 2009 Stepan Kasal <skasal@redhat.com> - 1:2.24-3
- Rebuild against perl 5.10.1

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1:2.24-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Tue Jun 02 2009 Chris Weyl <cweyl@alumni.drew.edu> - 1:2.24-1
- Auto-update to 2.24 (by cpan-spec-update 0.01)

* Thu Mar 26 2009 Chris Weyl <cweyl@alumni.drew.edu> - 2.2311-4
- Stripping bad provides of private Perl extension libs

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.2311-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.2311-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Sun Feb 22 2009 Chris Weyl <cweyl@alumni.drew.edu> - 2.2311-1
- Update to 2.2311

* Sun Sep 07 2008 Chris Weyl <cweyl@alumni.drew.edu> - 2.2222-1
- Update to the increasingly silly version of 2.2222
- Update files to include bin

* Wed Jun 25 2008 Chris Weyl <cweyl@alumni.drew.edu> - 2.21-1
- Update to 2.21

* Wed May 28 2008 Chris Weyl <cweyl@alumni.drew.edu> - 2.2-1
- Update to 2.2

* Sun Mar 09 2008 Chris Weyl <cweyl@alumni.drew.edu> - 2.01-1
- Update to 2.x series before F9

* Thu Mar 06 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 1.52-3
- Rebuild for new perl

* Mon Feb 18 2008 Fedora Release Engineering <rel-eng@fedoraproject.org> - 1.52-2
- Autorebuild for GCC 4.3

* Wed Oct 17 2007 Chris Weyl <cweyl@alumni.drew.edu> - 1.52-1
- Update to 1.52
- License tag update: GPL -> GPL+

* Tue Aug 21 2007 Chris Weyl <cweyl@alumni.drew.edu> - 1.43-2
- Bump

* Thu Aug 09 2007 Chris Weyl <cweyl@alumni.drew.edu> - 1.43-1
- Update to 1.43

* Fri Jun 01 2007 Chris Weyl <cweyl@alumni.drew.edu> - 1.22-1
- Update to 1.22

* Mon May 14 2007 Chris Weyl <cweyl@alumni.drew.edu> - 1.21-3
- Bump

* Mon May 14 2007 Chris Weyl <cweyl@alumni.drew.edu> - 1.21-2
- Add eg/ to doc

* Sun May 13 2007 Chris Weyl <cweyl@alumni.drew.edu> - 1.21-1
- Specfile autogenerated by cpanspec 1.71
